USE [COWS_Reporting]
GO
--==================================================================================
-- Project:			PJ004672 - COWS Reporting 
-- Author:			Brad Settle
-- Date:			08/03/2011
-- Description:		
--					GOM Carrier Partner Report.
--					Group Type:  GOM
--					QueryNumber: 1 = Daily
--								 2 = Weekly
--								 3 = Month to Date
--								 0 = Specify start date & end date: 'mm/dd/yyyy'
--
-- TEST: EXEC COWS_Reporting.dbo.sp_GOMRptMonthlyCarrierPartnerReport 1, 3
-- Updated By:   Md M Monir
-- Updated Date: 03/19/2018
-- Updated Reason: SCURD_CD/CSG_LVL_CD
--==================================================================================
ALTER Procedure [dbo].[sp_GOMRptMonthlyCarrierPartnerReport] 
	@secured			BIT=0,
	@QueryNumber		INT,
	@inStartDtStr		VARCHAR(10)='',
	@inEndDtStr			VARCHAR(10)=''
AS
BEGIN TRY

	SET NOCOUNT ON;
	
	DECLARE @startDate		DATETIME
	DECLARE @endDate		DATETIME
	DECLARE	@today			DATETIME
	DECLARE @startDtStr		VARCHAR(10)	
	DECLARE @dayOfWeek		INT

	IF @QueryNumber=0
		BEGIN
			SET @startDate=CONVERT(DATETIME, @inStartDtStr, 101)
			SET @endDate=CONVERT(DATETIME, @inEndDtStr, 101)				
			-- Add 1 day to End Date in order to cover the End Date 24-hr period
			SET @endDate=DATEADD(day, 1, @endDate) 
		END	
	ELSE IF @QueryNumber=1
    	BEGIN    	
    		-- e.g. Run date is '2011-06-15' , STRT_TMST >= 2011-06-15 00:00:00.000 and STRT_TMST < 2011-06-16 00:00:00.000
			SET @startDate=CAST(CONVERT(VARCHAR(8), GETDATE(), 112) AS DATETIME)
			SET @endDate=CAST(CONVERT(VARCHAR(8), DATEADD(DAY, 1, GETDATE()), 112) AS DATETIME)   
		END
	ELSE IF @QueryNumber=2
		BEGIN
			-- e.g. Run date is '2011-06-21' 3rd day of the week
			-- STRT_TMST >= 2011-06-12 00:00:00.000 and STRT_TMST < 2011-06-19 00:00:00.000
			SET @today=GETDATE()
			SET @dayOfWeek=DATEPART(dw, @today)
			SET @startDate=cast(CONVERT(VARCHAR(8), DATEADD(dd, -(@dayOfWeek+6), @today), 112) AS DATETIME)
			SET @endDate=cast(CONVERT(VARCHAR(8), DATEADD(dd, -(@dayOfWeek-1), @today), 112) AS DATETIME)
			--SET @startDate=cast(CONVERT(VARCHAR(8), DATEADD(dd, -7, GETDATE()), 112) As DateTime)
			--SET @endDate=cast(CONVERT(varchar(8), GETDATE(), 112) AS Datetime)		
		END
	ELSE IF @QueryNumber=3
		BEGIN			 
  			SET @today=DATEADD(MONTH,0,GETDATE())
    		-- e.g. Run date is the 1st day of each month 
    		-- STRT_TMST >= 2011-05-01 00:00:00.000 and STRT_TMST < 2011-06-01 00:00:00.000
  			SET @startDtStr=SUBSTRING(CONVERT(VARCHAR(10), @today, 101),1,2) + '/01/' + CAST(YEAR(@today) AS VARCHAR(4));  			
			SET @startDate=CAST(@startDtStr AS DATETIME)
			SET @endDate=CAST(CONVERT(VARCHAR(8), GETDATE()+1, 112) AS DATETIME)
		END

	--DECLARE @secured BIT=0 -- for testing purposes only

	OPEN SYMMETRIC KEY FS@K3y 
	DECRYPTION BY CERTIFICATE S3cFS@CustInf0; 

	SELECT DISTINCT 
		CASE 
			WHEN o.ORDR_CAT_ID=1 THEN convert(varchar(50),ipo.ORDR_ID)
			WHEN o.ORDR_CAT_ID=6 THEN fo.FTN 
			WHEN o.ORDR_CAT_ID=2 THEN fo.FTN END [Order Tracking No]
		,CASE
			--WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))	
			--WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER' 
			--WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN NULL
			--WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))	
			--WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER' 
			--WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN NULL 
			--WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME))	
			--WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER' 
			--WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NULL THEN NULL 
			--ELSE ISNULL(CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)),'') 
			
			o.ORDR_CAT_ID
			      WHEN 6 THEN
						 CASE  
							WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''
							ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END
				  WHEN 2 THEN
						 CASE  
							WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''
							ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END
				  WHEN 1 THEN
						 CASE  
							WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  h5f2.CUST_NME
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NOT NULL THEN  'PRIVATE CUSTOMER'
							WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NULL THEN  ''
							ELSE  COALESCE(csd.CUST_NME,h5f2.CUST_NME,'') END			
			 ELSE COALESCE(CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)),si.CUST_NME,si.CUST_NME2,'' ) 
			 END [Customer Name] --Secured
			
			
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lpt.PROD_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'') END [Product]
		,ISNULL(lkpf.PLTFRM_NME,'') as [Service Platform]
		,ISNULL(CAST(b5.MRC_CHG_AMT AS MONEY), 0) + ISNULL(CAST(b6.MRC_CHG_AMT AS MONEY), 0)  
		+ ISNULL(CAST(b1.MRC_CHG_AMT AS MONEY), 0) + ISNULL(CAST(b2.MRC_CHG_AMT AS MONEY), 0) 
		+ ISNULL(CAST(b3.MRC_CHG_AMT AS MONEY), 0) + ISNULL(CAST(b4.MRC_CHG_AMT AS MONEY), 0) 
		+ ISNULL(CAST(b7.MRC_CHG_AMT AS MONEY), 0) [Monthly Recurring Charge]
		,ISNULL(CAST(b5.NRC_CHG_AMT AS MONEY), 0) + ISNULL(CAST(b6.NRC_CHG_AMT AS MONEY), 0)  
		+ ISNULL(CAST(b1.NRC_CHG_AMT AS MONEY), 0) + ISNULL(CAST(b2.NRC_CHG_AMT AS MONEY), 0) 
		+ ISNULL(CAST(b3.NRC_CHG_AMT AS MONEY), 0) + ISNULL(CAST(b4.NRC_CHG_AMT AS MONEY), 0)
		+ ISNULL(CAST(b7.NRC_CHG_AMT AS MONEY), 0) [Non-Recurring Charge]
		,ISNULL(lkv.VNDR_NME,'') [Facility Provider]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(zzz.STUS_DES,'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(zz.STUS_DES,'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(zz.STUS_DES,'') END [Order Status]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN CONVERT(VARCHAR(10),ipo.CREAT_DT,101)
			WHEN o.ORDR_CAT_ID=6 THEN CONVERT(VARCHAR(10),fo.CREAT_DT,101)
			WHEN o.ORDR_CAT_ID=2 THEN CONVERT(VARCHAR(10),fo.CREAT_DT,101) END [FSA Order Creation Date]
		,CASE 
			WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lot.ORDR_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'')
			WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'') END [Service Request Type]
	FROM COWS.dbo.ORDR o with (nolock) 
		LEFT OUTER JOIN COWS.dbo.FSA_ORDR fo WITH (NOLOCK) ON o.ORDR_ID = fo.ORDR_ID
		LEFT OUTER JOIN COWS.dbo.LK_VNDR lkv WITH (NOLOCK) ON lkv.VNDR_CD = fo.INSTL_VNDR_CD
		LEFT OUTER JOIN COWS.dbo.IPL_ORDR ipo WITH (NOLOCK) ON o.ORDR_ID = ipo.ORDR_ID
		LEFT OUTER JOIN COWS.dbo.NRM_CKT nc WITH (NOLOCK) ON nc.FTN = fo.FTN
		LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f2 WITH (NOLOCK) ON h5f2.H5_FOLDR_ID = o.H5_FOLDR_ID
		LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=h5f2.H5_FOLDR_ID  AND csd.SCRD_OBJ_TYPE_ID=6
		LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f WITH (NOLOCK) ON h5f.H5_FOLDR_ID = o.H5_FOLDR_ID						
		LEFT OUTER JOIN COWS.dbo.LK_CTRY lkc5 WITH (NOLOCK) ON lkc5.CTRY_CD = h5f.CTRY_CD							
		LEFT OUTER JOIN COWS.dbo.LK_FSA_ORDR_TYPE lfot WITH (NOLOCK) ON lfot.FSA_ORDR_TYPE_CD = fo.ORDR_TYPE_CD
		LEFT OUTER JOIN COWS.dbo.LK_ORDR_TYPE lot WITH (NOLOCK) ON lot.ORDR_TYPE_ID = ipo.ORDR_TYPE_ID
		LEFT OUTER JOIN COWS.dbo.LK_FSA_PROD_TYPE lfpt WITH (NOLOCK) ON lfpt.FSA_PROD_TYPE_CD = fo.PROD_TYPE_CD
		LEFT OUTER JOIN COWS.dbo.LK_PROD_TYPE lpt WITH (NOLOCK) ON lpt.PROD_TYPE_ID = ipo.PROD_TYPE_ID
		LEFT OUTER JOIN COWS.dbo.LK_PLTFRM lkpf WITH (NOLOCK) ON lkpf.PLTFRM_CD = o.PLTFRM_CD
  		LEFT OUTER JOIN (SELECT ACT_TASK_ID,ORDR_ID,y.TASK_ID,STUS_ID,STUS_DES FROM (
			SELECT ACT_TASK_ID,ORDR_ID,TASK_ID FROM COWS.dbo.ACT_TASK at WITH (NOLOCK) 
			WHERE ACT_TASK_ID = (SELECT MAX(ACT_TASK_ID) 
				FROM COWS.dbo.ACT_TASK mat WITH (NOLOCK)
				WHERE mat.ORDR_ID=at.ORDR_ID)) y
			JOIN (SELECT TASK_ID,STUS_ID,STUS_DES 
				FROM COWS.dbo.LK_TASK lkt WITH (NOLOCK)
				JOIN COWS.dbo.LK_STUS lks WITH(NOLOCK) ON lks.STUS_ID=lkt.ORDR_STUS_ID) z ON z.TASK_ID=y.TASK_ID
			) zz on zz.ORDR_ID=fo.ORDR_ID
  		LEFT OUTER JOIN (SELECT ACT_TASK_ID,ORDR_ID,y.TASK_ID,STUS_ID,STUS_DES FROM (
			SELECT ACT_TASK_ID,ORDR_ID,TASK_ID FROM COWS.dbo.ACT_TASK at WITH (NOLOCK) 
			WHERE ACT_TASK_ID = (SELECT MAX(ACT_TASK_ID) 
				FROM COWS.dbo.ACT_TASK mat WITH (NOLOCK)
				WHERE mat.ORDR_ID=at.ORDR_ID)) y
			JOIN (SELECT TASK_ID,STUS_ID,STUS_DES 
				FROM COWS.dbo.LK_TASK lkt WITH (NOLOCK)
				JOIN COWS.dbo.LK_STUS lks WITH(NOLOCK) ON lks.STUS_ID=lkt.ORDR_STUS_ID) z ON z.TASK_ID=y.TASK_ID
			) zzz on zzz.ORDR_ID=ipo.ORDR_ID
		LEFT OUTER JOIN (SELECT bb.ORDR_ID, bb.SOI_CD, bb.CUST_NME, bb.BR_CD, CONVERT(varchar, DecryptByKey(csd.CUST_NME)) AS CUST_NME2
 			   FROM COWS.dbo.FSA_ORDR_CUST bb WITH (NOLOCK)
 			   LEFT OUTER JOIN COWS.dbo.FSA_ORDR cc WITH (NOLOCK) ON  bb.ORDR_ID = cc.ORDR_ID 
 			   LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=bb.FSA_ORDR_CUST_ID  AND csd.SCRD_OBJ_TYPE_ID=5
				WHERE (CIS_LVL_TYPE = 'H5' OR CIS_LVL_TYPE = 'H6') AND bb.SOI_CD = (SELECT MAX(SOI_CD)
					FROM (SELECT SOI_CD, ORDR_ID 
						FROM [COWS].[dbo].[FSA_ORDR_CUST] WITH (NOLOCK)) soi
					WHERE soi.ORDR_ID = bb.ORDR_ID AND (CIS_LVL_TYPE = 'H5' OR CIS_LVL_TYPE = 'H6'))) si ON si.ORDR_ID = fo.ORDR_ID 

		LEFT OUTER JOIN (SELECT bb.BIC_CD, bb.LINE_ITEM_DES, bb.ORDR_ID, bb.MRC_CHG_AMT, 
		bb.NRC_CHG_AMT FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 1) b1 on o.ORDR_ID = b1.ORDR_ID 
		
		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 2) b2 on o.ORDR_ID = b2.ORDR_ID

		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 3) b3 on o.ORDR_ID = b3.ORDR_ID
		
		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 4) b4 on o.ORDR_ID = b4.ORDR_ID

		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.BIC_CD, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 5 AND bb.LINE_ITEM_DES LIKE '%Access%') b5 on o.ORDR_ID = b5.ORDR_ID

		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.BIC_CD, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 5 AND bb.LINE_ITEM_DES LIKE '%PORT%') b6 on o.ORDR_ID = b6.ORDR_ID
		
		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 7) b7 on o.ORDR_ID = b7.ORDR_ID
		
		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 8) b8 on o.ORDR_ID = b8.ORDR_ID

		LEFT OUTER JOIN (SELECT bb.LINE_ITEM_DES, bb.ORDR_ID, bb.MRC_CHG_AMT, bb.NRC_CHG_AMT 
		FROM [COWS].[dbo].[FSA_ORDR_BILL_LINE_ITEM] bb WITH (NOLOCK)
		JOIN [COWS].dbo.[ORDR] cc WITH (NOLOCK) ON cc.ORDR_ID = bb.ORDR_ID 
		WHERE bb.BILL_ITEM_TYPE_ID = 9) b9 on o.ORDR_ID = b9.ORDR_ID

	WHERE (ipo.ORDR_ID IS NOT NULL OR fo.FTN IS NOT NULL)
	 	AND lfpt.FSA_PROD_TYPE_CD IN ('DO','SO','MO')
		AND lfot.FSA_ORDR_TYPE_DES = 'Install'
		AND ((fo.CREAT_DT >= @startDate AND fo.CREAT_DT < @endDate) OR (ipo.CREAT_DT >= @startDate AND ipo.CREAT_DT < @endDate)) 

	CLOSE SYMMETRIC KEY FS@K3y 
	
	RETURN 0;

END TRY

BEGIN CATCH
	DECLARE @Desc VARCHAR(200)
	SET @Desc='EXEC COWS_Reporting.dbo.sp_GOMRptMonthlyCarrierPartnerReport '  + CAST(@QueryNumber AS VARCHAR(4)) + ': '
	SET @Desc=@Desc + CONVERT(VARCHAR(10), @startDate, 101) + ', ' + CONVERT(VARCHAR(10), @endDate, 101)
	EXEC RAD_Reporting.rad.sp_ReportProcessLog null, @Desc, null, null, null;
	RETURN 1;
END CATCH




